#include "user.h"
#include "LH155.h"


#define fr_div_set		PG1
#define fr_div_clr		PG0

#define	att_set			PD7
#define att_clr			PD6

#define run 			PG2

#define inp_sel			PG3
#define sync_sw_pin		PG4

#define h_l_pin			PB4

#define clk_mcu			PD5

#define r_w				PD4

//   
void run_osc (void);
void mcu_clk_imp(void);

//     
//	
void freq_div_sel(unsigned char f_d);
void att_sel(unsigned char d);

void inp_sw(unsigned char k_inp_sw);
void sync_sw(unsigned char k_sync_sw);

//
inline void gird (void);
void axis (void);

void sinc_on_off(unsigned char k_s);
void sinc_on_off_ind(unsigned char k_s);

void v_d_ind (unsigned char k_att);
void f_d_ind (unsigned char k_fr_div);

void h_l_sw(unsigned char h_l_sw);

//      
unsigned char max_arr(unsigned char arr[]);
unsigned char min_arr(unsigned char arr[]);
unsigned char av_arr(unsigned char arr[]);
unsigned char get_fr (unsigned char arr[]);


void solid_beam_set(unsigned char x, unsigned char y1, unsigned char y2);
void solid_beam_clear(unsigned char x, unsigned char y1, unsigned char y2);
