#include "osc.h"

void gird (void)
{
	//
	//  
	for (unsigned char i=1; i<126; i=i+2)
	{
		glcd_set_dot(i, 36);
	}
	//  
	for (unsigned char i=10; i<63; i=i+2)
	{
		glcd_set_dot(63, i);
	}
	
	
	
	//  I
	for (unsigned char j=0;j<63;j=j+7)
	{
		for (unsigned char i=15; i<36; i=i+7)
		{
			glcd_set_dot(j, i);
		}
	}

	for (unsigned char j=0;j<63;j=j+7)
	{
		for (unsigned char i=43; i<64; i=i+7)
		{
			glcd_set_dot(j, i);
		}
	}
	
	//  II
	for (unsigned char j=70;j<128;j=j+7)
	{
		for (unsigned char i=15; i<36; i=i+7)
		{
			glcd_set_dot(j, i);
		}
	}
	
	for (unsigned char j=70;j<128;j=j+7)
	{
		for (unsigned char i=43; i<64; i=i+7)
		{
			glcd_set_dot(j, i);
		}
	}
	
}

void axis (void)
{
// 
	glcdRectangle(0, 9, 55, 127);
	
	return;
}

void run_osc (void)
{
	PORTG&=~_BV(run);
	PORTG|=_BV(run);
	pause(1);
	PORTG&=~_BV(run);
	pause(1);
	return;
}

void mcu_clk_imp(void)
{
	PORTD&=~_BV(clk_mcu);
	PORTD|=_BV(clk_mcu);
	pause(1);
	PORTD&=~_BV(clk_mcu);
	pause(1);
	return;
}

void inp_sw(unsigned char k_inp_sw)
{
	switch (k_inp_sw)
	{
		case 0: 
			PORTG|=_BV(inp_sel);
			glcd_put_char(88, 1,1);
			break;
		case 1:
			PORTG&=~_BV(inp_sel);
			glcd_put_char(88, 1,2);
			break;
		default:
			break;
	}
	return;
}

void h_l_sw(unsigned char k_h_l)
{
	switch (k_h_l)
	{
		case 0: 
			PORTB|=_BV(h_l_pin);
			glcd_put_char(104, 1,5);
			break;
		case 1:
			PORTB&=~_BV(h_l_pin);
			glcd_put_char(104, 1,6);
			break;
		default:
			break;
	}
	return;
}

void sync_sw(unsigned char k_sync_sw)
{
	switch (k_sync_sw)
	{
		case 0: //	
			PORTG|=_BV(sync_sw_pin);
			glcd_put_char(96, 1,3);
			break;
		case 1:		//
			PORTG&=~_BV(sync_sw_pin);
			glcd_put_char(96, 1,4);
			break;
		default:
			break;
	}
	return;
}

/*
// math

unsigned char max_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_<arr[i])	tmp_=arr[i];
	}
	return 46-tmp_;
}

unsigned char min_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_>arr[i])	tmp_=arr[i];
	}
	return 46-tmp_;
}


unsigned char av_arr(unsigned char arr[])
{ 
	unsigned int tmp_=0;
	unsigned char i;
	for (i=0;i<0xff;i++)
	{
		tmp_=tmp_+arr[i];
	}
	tmp_=tmp_/0xff;
	return 46-tmp_;
}

unsigned char get_fr (unsigned char arr[])
{
	unsigned char U_eg=25,i_eg_1=0,i_eg_2=0,i_eg_3=0, i=0;
	
	while ((arr[i]==U_eg)||i==127)	i++;
	i_eg_1=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_2=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_3=i;

	return i_eg_3-i_eg_1;
	
}
*/

void sinc_on_off(unsigned char k_s)
{

		switch (k_s)
		{
			case 0:
				TIMSK|=_BV(TOIE0);
				break;
			case 1:
				EIMSK|=_BV(INT1); 
				break;
			default:
				TIMSK|=_BV(TOIE0);
				break;
		}
	return;
}

void sinc_on_off_ind(unsigned char k_s)
{
	switch (k_s)
	{
		case 0: 	//
		glcd_put_char(116, 1,45);
			break;
		case 1:		//
		glcd_put_char(116, 1,44);
			break;
		default:
			break;
	}
}

void att_sel(unsigned char d)
{
	PORTD&=~_BV(att_clr);
	PORTD|=_BV(att_clr);
	pause(1);
	PORTD&=~_BV(att_clr);
	pause(1);
	
	for (unsigned char c=0;c<d;c++)
	{
		PORTD&=~_BV(att_set	);
		PORTD|=_BV(att_set);
		pause(1);
		PORTD&=~_BV(att_set);
		pause(1);
	}
	return;
}

void v_d_ind (unsigned char k_att)
{
	switch (k_att)
	{
		case 0: 
			glcd_put_txt(0,1," 1 ");
			break;
		case 1:
			glcd_put_txt(0,1,"0.5");
			break;
		case 2:
			glcd_put_txt(0,1,"0.2");
			break;
		case 3:
			glcd_put_txt(0,1,"0.1");
			break;
		case 4:
			glcd_put_txt(0,1,"50m");
			break;
		case 5:
			glcd_put_txt(0,1,"20m");
			break;
		default:
			break;
	}
	return;
}


void freq_div_sel(unsigned char f_d)
{
	PORTG&=~_BV(fr_div_clr);
	PORTG|=_BV(fr_div_clr);
	pause(1);
	PORTG&=~_BV(fr_div_clr);
	pause(1);
	
	for (unsigned char c=0;c<=f_d;c++)
	{
		PORTG&=~_BV(fr_div_set);
		PORTG|=_BV(fr_div_set);
		pause(2);
		PORTG&=~_BV(fr_div_set);
		pause(2);
	}
	return;
}


void f_d_ind (unsigned char k_fr_div)
{
	switch (k_fr_div)
	{
		case 0: 
			glcd_put_txt(40,1,"0.1u");
			break;
		case 1:
			glcd_put_txt(40,1,"0.2u");
			break;
		case 2:
			glcd_put_txt(40,1,"0.4u");
			break;
		case 3:
			glcd_put_txt(40,1,"0.8u");
			break;
		case 4:
			glcd_put_txt(40,1,"1.6u");;
			break;
		case 5:
			glcd_put_txt(40,1,"3.2u");
			break;
		case 6:
			glcd_put_txt(40,1,"6.4u");;
			break;
		case 7:
			glcd_put_txt(40,1,"12 u");
			break;
		case 8:
			glcd_put_txt(40,1,"25 u");
			break;
		case 9:
			glcd_put_txt(40,1,"50 u");
			break;
		case 10:
			glcd_put_txt(40,1,"100u");
			break;
		case 11:
			glcd_put_txt(40,1,"200u");
			break;
		case 12:
			glcd_put_txt(40,1,"400u");;
			break;
		case 13:
			glcd_put_txt(40,1,"800u");
			break;
		case 14:
			glcd_put_txt(40,1,"1.6m");
			break;
		case 15:
			glcd_put_txt(40,1,"3.2m");
			break;
		default:
			break;
	}
	
	return;
}


void solid_beam_set(unsigned char x, unsigned char y1, unsigned char y2)
{
	if(y1<y2) for (unsigned char y=y1;y<y2;y++)	glcd_set_dot(x,y);
	if (y1>y2)	for (unsigned char y=y1;y>y2;y--)	glcd_set_dot(x,y);
	else glcd_set_dot(x,y1);
}

void solid_beam_clear(unsigned char x, unsigned char y1, unsigned char y2)
{
	if(y1<y2) for (unsigned char y=y1;y<y2;y++)	glcd_clear_dot(x,y);
	if (y1>y2)	for (unsigned char y=y1;y>y2;y--)	glcd_clear_dot(x,y);
	else glcd_clear_dot(x,y1);
}
