#include "user.h"
#include "disp.h"

#define fr_div_set		PD3
#define fr_div_clr		PD4

#define	att_set			PG4
#define att_clr			PG3

#define clk_mcu			PD6
#define r_w				PD5

#define run 			PD2

#define inp_sel			PD7
#define sync_sw_pin		PG1
#define sync_h_l		PG0


#define on	1
#define off	0


//   
void run_osc (void);
void mcu_clk_imp(void);

//     
//	
void freq_div_sel(unsigned char f_d);
void att_sel(unsigned char d);

void inp_sw(unsigned char k_inp_sw);
void sync_sw(unsigned char k_sync_sw);


void sinc_on_off(unsigned char k_s);
void sinc_on_off_ind(unsigned char k_s);

void v_d_ind (unsigned char k_att);
void f_d_ind (unsigned char k_fr_div);
void h_l_sync (unsigned char k_h_l);


