#include"graph.h"
#include"disp.h"

/*
//------------  ----------------
void led_ind(unsigned char l)
{
	static unsigned char n=0;
	for (n=l;n>0;n--)
	{
		PORTB|=_BV(PB7);
		pause(400);
		PORTB&=~_BV(PB7);
		pause(400);
	}
	return;
}
*/

/*
//----------------------------------------------------
void uart_putchar(unsigned char value)
{
	loop_until_bit_is_set(UCSRA, UDRE);
    UDR = value;
	return;
}
*/
//---------------------------------------------------------------------

void gclcd_put_val_4dig(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{
	put_char(pos_x,pos_y,(val/1000 + 0x30),rot_);
	put_char(pos_x+8,pos_y,((val/100)%10 + 0x30),rot_);
	put_char(pos_x+16,pos_y,((val/10)%10 + 0x30),rot_);
	put_char(pos_x+24,pos_y,(val%10 + 0x30), rot_);
}
void gclcd_put_val_4dig_2comma(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{

	put_char(pos_x,pos_y,(val/1000 + 0x30),rot_);
	put_char(pos_x+8,pos_y,(val/100)%10 + 0x30,rot_);
	//put_char(pos_x+16,pos_y,".",rot_);
	gclcd_put_txt(pos_x+16,pos_y,".",0);
	put_char(pos_x+24,pos_y,(val/10)%10 + 0x30,rot_);
	//put_char(pos_x+24,pos_y,(val%10 + 0x30), rot_);
}
void gclcd_put_val_4dig_1comma(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{
	put_char(pos_x,pos_y,(val/1000 + 0x30),rot_);
	gclcd_put_txt(pos_x+8,pos_y,".",0);
	put_char(pos_x+16,pos_y,((val/100)%10 + 0x30),rot_);
	put_char(pos_x+24,pos_y,((val/10)%10 + 0x30),rot_);
	//put_char(pos_x+24,pos_y,(val%10 + 0x30), rot_);
}
void gclcd_put_val_4dig_3comma(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{	
	put_char(pos_x,pos_y,(val/1000 + 0x30),rot_);
	put_char(pos_x+8,pos_y,((val/100)%10 +0x30),rot_);
	put_char(pos_x+16,pos_y,((val/10)%10 + 0x30),rot_);
	gclcd_put_txt(pos_x+24,pos_y,".",0);
	//put_char(pos_x+24,pos_y,(val%10 + 0x30), rot_);
}
void gclcd_put_val_3dig(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{
	put_char(pos_x,pos_y,((val/100)%10 + 0x30),rot_);
	put_char(pos_x+8,pos_y,((val/10)%10 + 0x30),rot_);
	put_char(pos_x+16,pos_y,(val%10 + 0x30), rot_);
}
void gclcd_put_val_2dig(unsigned char pos_x,unsigned char pos_y,unsigned int val,unsigned char rot_)
{
	put_char(pos_x,pos_y,((val/10)%10 + 0x30),rot_);
	put_char(pos_x+8,pos_y,(val%10 + 0x30), rot_);
}

void gclcd_put_txt (unsigned char pos_x,unsigned char pos_y,unsigned char txt[],unsigned char rot_)
{
	unsigned char i;
	i=0;
	while (txt[i]!=0)
	{
		put_char(pos_x+i*CHAR_W,pos_y,txt[i],rot_);   //  0 deg. rotated
		i++;
	}
}

void gclcd_put_pixel(unsigned char x, unsigned char y, unsigned Color)
{ 

  //uint16_t i,h;

  PORTB &= ~_BV(LCD_CS);  // select display

      lcd_comtype(0x05);
      lcd_comdat(0x00,0x38);
      lcd_comtype(0x17);
      lcd_comdat(x, x);
      lcd_comtype(0x16);
      lcd_comdat(y, y);
      lcd_comtype(0x21);
      lcd_comdat(x,y);
      lcd_comtype(0x22);
      lcd_write(0x76); 
	  
	  lcd_write16(Color);
	PORTB |= _BV(LCD_CS);  // deselect display    
}
void glcdRectangle(unsigned char x, unsigned char y, unsigned char a, unsigned char b,unsigned int Color)
{
	unsigned char j;
	
	for (j = 0; j < a; j++) 
	{
		gclcd_put_pixel(x, y + j,Color);
		gclcd_put_pixel(x + b - 1, y + j,Color);
	}
	for (j = 0; j < b; j++)
	{
		gclcd_put_pixel(x + j, y,Color);
		gclcd_put_pixel(x + j, y + a - 1,Color);
	}
}

inline void glcgLine (unsigned char a,unsigned char b,unsigned char c,unsigned char d,unsigned int Color)
{
	for ((a=50)&(b=40);(c<100)&(d<80); (a++)&(b++))
	{
		gclcd_put_pixel(a,b,Color);
	}
	return;
}

inline void gird (unsigned int girdcolor)
{

// gird
	gclcd_put_pixel(11,122, girdcolor);
	gclcd_put_pixel(11,112, girdcolor);
	gclcd_put_pixel(11,102, girdcolor);
	gclcd_put_pixel(11,92, girdcolor);
	//gclcd_put_pixel(50,16, gird_color);
	gclcd_put_pixel(11,72, girdcolor);
	gclcd_put_pixel(11,62, girdcolor);
	gclcd_put_pixel(11,52, girdcolor);
	gclcd_put_pixel(11,42, girdcolor);
	
	gclcd_put_pixel(22,122, girdcolor);
	gclcd_put_pixel(22,112, girdcolor);
	gclcd_put_pixel(22,102, girdcolor);
	gclcd_put_pixel(22,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(22,72, girdcolor);
	gclcd_put_pixel(22,62, girdcolor);
	gclcd_put_pixel(22,52, girdcolor);
	gclcd_put_pixel(22,42, girdcolor);
	
	gclcd_put_pixel(33,122, girdcolor);
	gclcd_put_pixel(33,112, girdcolor);
	gclcd_put_pixel(33,102, girdcolor);
	gclcd_put_pixel(33,92, girdcolor);
	//gclcd_put_pixel(50,16, gird_color);
	gclcd_put_pixel(33,72, girdcolor);
	gclcd_put_pixel(33,62, girdcolor);
	gclcd_put_pixel(33,52, girdcolor);
	gclcd_put_pixel(33,42, girdcolor);
	
	gclcd_put_pixel(44,122, girdcolor);
	gclcd_put_pixel(44,112, girdcolor);
	gclcd_put_pixel(44,102, girdcolor);
	gclcd_put_pixel(44,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(44,72, girdcolor);
	gclcd_put_pixel(44,62, girdcolor);
	gclcd_put_pixel(44,52, girdcolor);
	gclcd_put_pixel(44,42, girdcolor);
	
	gclcd_put_pixel(55,122, girdcolor);
	gclcd_put_pixel(55,112, girdcolor);
	gclcd_put_pixel(55,102, gird_color);
	gclcd_put_pixel(55,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(55,72, girdcolor);
	gclcd_put_pixel(55,62, girdcolor);
	gclcd_put_pixel(55,52, girdcolor);
	gclcd_put_pixel(55,42, girdcolor);
	
	gclcd_put_pixel(66,122, girdcolor);
	gclcd_put_pixel(66,102, girdcolor);
	gclcd_put_pixel(66,92, girdcolor);
	gclcd_put_pixel(66,82, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(66,72, girdcolor);
	gclcd_put_pixel(66,62, girdcolor);
	gclcd_put_pixel(66,52, girdcolor);
	gclcd_put_pixel(66,42, girdcolor);
	
	gclcd_put_pixel(77,122, girdcolor);
	gclcd_put_pixel(77,112, girdcolor);
	gclcd_put_pixel(77,102, girdcolor);
	gclcd_put_pixel(77,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(77,72, girdcolor);
	gclcd_put_pixel(77,62, girdcolor);
	gclcd_put_pixel(77,52, girdcolor);
	gclcd_put_pixel(77,42, girdcolor);
	
	gclcd_put_pixel(99,122, girdcolor);
	gclcd_put_pixel(99,112, girdcolor);
	gclcd_put_pixel(99,102, girdcolor);
	gclcd_put_pixel(99,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(99,72, girdcolor);
	gclcd_put_pixel(99,62, girdcolor);
	gclcd_put_pixel(99,52, girdcolor);
	gclcd_put_pixel(99,42, girdcolor);
	
	gclcd_put_pixel(111,122, girdcolor);
	gclcd_put_pixel(111,112, girdcolor);
	gclcd_put_pixel(111,102, girdcolor);
	gclcd_put_pixel(111,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(111,72, girdcolor);
	gclcd_put_pixel(111,62, girdcolor);
	gclcd_put_pixel(111,52, girdcolor);
	gclcd_put_pixel(111,42, girdcolor);
	
	gclcd_put_pixel(121,122, girdcolor);
	gclcd_put_pixel(121,112, girdcolor);
	gclcd_put_pixel(121,102, girdcolor);
	gclcd_put_pixel(121,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(121,72, girdcolor);
	gclcd_put_pixel(121,62, girdcolor);
	gclcd_put_pixel(121,52, girdcolor);
	gclcd_put_pixel(121,42, girdcolor);


	gclcd_put_pixel(132,122, girdcolor);
	gclcd_put_pixel(132,112, girdcolor);
	gclcd_put_pixel(132,102, girdcolor);
	gclcd_put_pixel(132,92, girdcolor);
	//gclcd_put_pixel(50,16, gird_color);
	gclcd_put_pixel(132,72, girdcolor);
	gclcd_put_pixel(132,62, girdcolor);
	gclcd_put_pixel(132,52, girdcolor);
	gclcd_put_pixel(132,42, girdcolor);
	
	gclcd_put_pixel(143,122, girdcolor);
	gclcd_put_pixel(143,112, girdcolor);
	gclcd_put_pixel(143,102, girdcolor);
	gclcd_put_pixel(143,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(143,72, girdcolor);
	gclcd_put_pixel(143,62, girdcolor);
	gclcd_put_pixel(143,52, girdcolor);
	gclcd_put_pixel(143,42, girdcolor);
	
	gclcd_put_pixel(154,122, girdcolor);
	gclcd_put_pixel(154,112, girdcolor);
	gclcd_put_pixel(154,102, girdcolor);
	gclcd_put_pixel(154,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(154,72, girdcolor);
	gclcd_put_pixel(154,62, girdcolor);
	gclcd_put_pixel(154,52, girdcolor);
	gclcd_put_pixel(154,42, girdcolor);
	
	gclcd_put_pixel(165,122, girdcolor);
	gclcd_put_pixel(165,112, girdcolor);
	gclcd_put_pixel(165,102, girdcolor);
	gclcd_put_pixel(165,92, girdcolor);
	//gclcd_put_pixel(50,16, girdcolor);
	gclcd_put_pixel(165,72, girdcolor);
	gclcd_put_pixel(165,62, girdcolor);
	gclcd_put_pixel(165,52, girdcolor);
	gclcd_put_pixel(165,42, girdcolor);
	return;
}

inline void axis (unsigned int girdcolor)
{

// axis X

	glcdRectangle(1, 82, 1, 176,girdcolor);

	
// axis Y
	glcdRectangle(88, 32, 99, 1,girdcolor);
// edge
	glcdRectangle(0, 32, 100, 176,girdcolor);
	
// parameters

	glcdRectangle(138, 8, 17, 20,0xF800);
	glcdRectangle(108, 8, 17, 28,0xF800);
	glcdRectangle(70, 8, 17, 11,0xF800);
	glcdRectangle(83, 8, 17, 23,0xF800);
	return;
}


inline void bat_ch (unsigned int u_bat)
{
	glcdRectangle(164, 22, 1, 6,0xF800);
	glcdRectangle(164, 23, 1, 6,0xF800);
	glcdRectangle(162, 4, 18, 10,0xF800);
	
	if (u_bat>1020)	
	{
		glcdRectangle(164, 6, 1, 6,0xF800);
		glcdRectangle(164, 7, 1, 6,0xF800);
		glcdRectangle(164, 8, 1, 6,0xF800);	
		glcdRectangle(164, 9, 1, 6,0xF800);
		
		glcdRectangle(164, 11, 1, 6,0xF800);		
		glcdRectangle(164, 12, 1, 6,0xF800);	
		glcdRectangle(164, 13, 1, 6,0xF800);	
		glcdRectangle(164, 14, 1, 6,0xF800);
		
		glcdRectangle(164, 16, 1, 6,0xF800);		
		glcdRectangle(164, 17, 1, 6,0xF800);
		glcdRectangle(164, 18, 1, 6,0xF800);
		glcdRectangle(164, 19, 1, 6,0xF800);
		
	}
	if ((u_bat<=1020)&&(u_bat>=950))	// 
	{
		glcdRectangle(164, 6, 1, 6,0xF800);
		glcdRectangle(164, 7, 1, 6,0xF800);
		glcdRectangle(164, 8, 1, 6,0xF800);	
		glcdRectangle(164, 9, 1, 6,0xF800);
		
		glcdRectangle(164, 11, 1, 6,0xF800);		
		glcdRectangle(164, 12, 1, 6,0xF800);	
		glcdRectangle(164, 13, 1, 6,0xF800);	
		glcdRectangle(164, 14, 1, 6,0xF800);
		
		glcdRectangle(164, 16, 1, 6,0x00);		
		glcdRectangle(164, 17, 1, 6,0x00);
		glcdRectangle(164, 18, 1, 6,0x00);
		glcdRectangle(164, 19, 1, 6,0x00);
	}
	
	if ((u_bat<950)&&(u_bat>=850))	// 
	{
		glcdRectangle(164, 6, 1, 6,0xF800);
		glcdRectangle(164, 7, 1, 6,0xF800);
		glcdRectangle(164, 8, 1, 6,0xF800);	
		glcdRectangle(164, 9, 1, 6,0xF800);
		
		glcdRectangle(164, 11, 1, 6,0x00);		
		glcdRectangle(164, 12, 1, 6,0x00);	
		glcdRectangle(164, 13, 1, 6,0x00);	
		glcdRectangle(164, 14, 1, 6,0x00);
		
		glcdRectangle(164, 16, 1, 6,0x00);		
		glcdRectangle(164, 17, 1, 6,0x00);
		glcdRectangle(164, 18, 1, 6,0x00);
		glcdRectangle(164, 19, 1, 6,0x00);
	}
	if (u_bat<819)
	{
		glcdRectangle(164, 6, 1, 6,0x00);
		glcdRectangle(164, 7, 1, 6,0x00);
		glcdRectangle(164, 8, 1, 6,0x00);	
		glcdRectangle(164, 9, 1, 6,0x00);
		
		glcdRectangle(164, 11, 1, 6,0x00);		
		glcdRectangle(164, 12, 1, 6,0x00);	
		glcdRectangle(164, 13, 1, 6,0x00);	
		glcdRectangle(164, 14, 1, 6,0x00);
		
		glcdRectangle(164, 16, 1, 6,0x00);		
		glcdRectangle(164, 17, 1, 6,0x00);
		glcdRectangle(164, 18, 1, 6,0x00);
		glcdRectangle(164, 19, 1, 6,0x00);
	}
	return;
}

inline void solid_beam_set(unsigned char x, unsigned char y1, unsigned char y2)
{
	unsigned char y;
	if(y1<y2) for (y=y1;y<y2;y++)	gclcd_put_pixel(x,y,0xffff);
	if (y1>y2)	for (y=y1;y>y2;y--)	gclcd_put_pixel(x,y,0xffff);
	else gclcd_put_pixel(x,y1,WHITE);
}

inline void solid_beam_clear(unsigned char x, unsigned char y1, unsigned char y2)
{
	unsigned char y;
	if(y1<y2) for (y=y1;y<y2;y++)	gclcd_put_pixel(x,y,0x0000);
	if (y1>y2)	for (y=y1;y>y2;y--)	gclcd_put_pixel(x,y,0x0000);
	else gclcd_put_pixel(x,y1,BLACK);
}
