#include <avr/io.h>             // -
#include <util/delay.h>     //   
#include <avr/interrupt.h>        //  
#include <avr/eeprom.h>      //   EEPROM
#include <avr/sleep.h>

#include "font5x7.h"
#include "glcd.h"
#include "ks0108.h"
#include "avrlibdefs.h"
#include "avrlibtypes.h"
#include "fontgr.h"
#include "global.h"
#include "ks0108conf_sbr.h"
//#include "wallpaper.h"

#define VREF 5000

//            
unsigned char key (unsigned char kn);     // 
unsigned char keyB (unsigned char kn);
unsigned char keyD (unsigned char kn);
unsigned char keyE (unsigned char kn) ;
void led_ind(unsigned char l);
void pause (unsigned int p);

// ---   33-----------
unsigned char matrix_kbd(void);

//void four_dig_to_UART (unsigned long value);
//void uart_putchar(unsigned char value);
unsigned char res_ADC (void);


//----------------------------------------------------------------------------------------------
//void screen_saver (unsigned char wallpaper[]);

void glcdDigIndication_LINE1(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE2(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE3(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE4(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE5(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE6(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE7(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE8(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE2_5dig(unsigned char X_pos,unsigned int val);

void glcdDigIndication_LINE1_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE2_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE3_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE4_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE5_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE6_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE7_2dig(unsigned char X_pos,unsigned int val);
void glcdDigIndication_LINE8_2dig(unsigned char X_pos,unsigned int val);

void glcdDigIndication_LINE8_3dig(unsigned char X_pos,unsigned int val);
